#ifndef _CAESAR_H_
#define _CAESAR_H_

#include <stdint.h>
#include <stddef.h>

/**
 * Decrypts a message by shifting the characters.
 * The procedure directly overwrites the input message.
 *
 * @param message The message to encrypt.
 * @param message_length The length of the message in bytes.
 * @param key The number of characters each character of
 * the message is shifted by.
 */
void caesar_encrypt(char * const message, const size_t message_length, const int16_t key);

/**
 * Decrypts a message by shifting the characters to the left.
 * The procedure directly overwrites the input message.
 *
 * @param message The message to decrypt.
* @param message_length The length of the message in bytes.
 * @param key The number of characters each character of
 * the message is shifted by.
 */
void caesar_decrypt(char * const message, const size_t message_length, const int16_t key);

#endif
