#include <stdio.h>

#include "sheep_coordinate.h"

#define BUFSIZE 1024

int main(int argc, char *argv[])
{
	/* check if necessary filename argument is present */
	if (argc < 2)
	{
		printf("usage: %s <filename>\n", argv[0]);
		return 1;
	}

	/* Stack-allocate buffer for coordinate records. */
	sheep_coordinate_t coordinates[BUFSIZE];
	/* Try read records from given binary file. */
	int count = read_coordinates_from_file(argv[1], coordinates, BUFSIZE, true);
	if (count < 0) /* if reading unsuccessful (read_coordinates_from_file returns -1) */
	{
		printf("Could not open file %s.\n", argv[1]);
		return 1;
	}
	else
	{
		printf("%i entries in file %s:\n", count, argv[1]);
	}

	/* Print the table header. */
	printf("%-10s%-*s,%-*s\n", "Index", SHEEP_COORDINATE_T_PLACE_LEN, "Ort/Taetigkeit", SHEEP_COORDINATE_T_TIME_LEN, "Zeit");
	for (size_t i = 0; i < 10 + SHEEP_COORDINATE_T_PLACE_LEN + SHEEP_COORDINATE_T_TIME_LEN; i++)
	{
		putchar('-');
	}
	putchar('\n');

	/* Print all sheep coordinate records. */
	for (int i = 0; i < count; i++)
	{
		sheep_coordinate_t *c = &coordinates[i];
		printf("%-10u%-*s%-*s\n", c->index, SHEEP_COORDINATE_T_PLACE_LEN, c->place, SHEEP_COORDINATE_T_TIME_LEN, c->time);
	}

	return 0;
}
