#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "sheep_coordinate.h"
#include "caesar.h"

int read_coordinates_from_file(const char *filename, const sheep_coordinate_t *buf, const size_t bufsize, bool decrypt)
{
	FILE *f = fopen(filename, "r");
	if (f == NULL)
		return -1;
	/* Read as much data as the buffer can hold. */
	int count = fread((void*)buf, sizeof(buf[0]), bufsize, f);
	fclose(f);
	/* Optional decryption. */
	if (decrypt)
		caesar_decrypt((char *)buf, sizeof(buf[0]) * count, 11);
	return count;
}

int write_coordinates_to_file(const char *filename, const sheep_coordinate_t *buf, const size_t count, bool encrypt)
{
	FILE *f = fopen(filename, "w");
	if (f == NULL)
		return -1;

	int written = 0;

	/* Optional encryption */
    if (encrypt) {
		/* Make a copy before encrypting. */
		char *encrypted_coordinates = (char *)malloc(sizeof(buf[0]) * count);
		memcpy(encrypted_coordinates, buf, sizeof(buf[0]) * count);

		caesar_encrypt(encrypted_coordinates, sizeof(buf[0]) * count, 11);

		written = fwrite((void*)encrypted_coordinates, sizeof(buf[0]), count, f);
		free(encrypted_coordinates);
	}
	else
	{
		written = fwrite((void*)buf, sizeof(buf[0]), count, f);
	}
	fclose(f);
	return written;
}
